VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5595
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   6360
   LinkTopic       =   "Form1"
   ScaleHeight     =   5595
   ScaleWidth      =   6360
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   615
   End
   Begin VB.PictureBox Picture1 
      BorderStyle     =   0  'None
      Height          =   975
      Left            =   360
      ScaleHeight     =   975
      ScaleWidth      =   1215
      TabIndex        =   0
      Top             =   240
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Type BITMAP '14 bytes
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type
Private Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type
Private Const DIB_RGB_COLORS = 0&
Private Const BI_RGB = 0&

Private Const pixR As Integer = 3
Private Const pixG As Integer = 2
Private Const pixB As Integer = 1

Private Sub cmdGo_Click()
Static use_red As Boolean
Dim start_time As Single
Dim stop_time As Single
Dim clr As Integer
Dim wid As Integer
Dim hgt As Integer
Dim bitmap_info As BITMAPINFO
Dim pixels() As Byte
Dim bytes_per_scanLine As Integer
Dim pad_per_scanLine As Integer
Dim X As Integer
Dim Y As Integer

    Screen.MousePointer = vbHourglass
    DoEvents
    start_time = Timer

    ' Pick the color to fill with.
    If use_red Then
        clr = pixR
    Else
        clr = pixB
    End If
    use_red = Not use_red

    ' Prepare the bitmap description.
    wid = Picture1.ScaleWidth
    hgt = Picture1.ScaleHeight
    With bitmap_info.bmiHeader
        .biSize = 40
        .biWidth = wid
        ' Use negative height to scan top-down.
        .biHeight = -hgt
        .biPlanes = 1
        .biBitCount = 32
        .biCompression = BI_RGB
        bytes_per_scanLine = ((((.biWidth * .biBitCount) + 31) \ 32) * 4)
        pad_per_scanLine = bytes_per_scanLine - (((.biWidth * .biBitCount) + 7) \ 8)
        .biSizeImage = bytes_per_scanLine * Abs(.biHeight)
    End With

    ' Load the bitmap's data.
    ReDim pixels(1 To 4, 1 To wid, 1 To hgt)
    GetDIBits Picture1.hdc, Picture1.Image, _
        0, hgt, pixels(1, 1, 1), _
        bitmap_info, DIB_RGB_COLORS

    ' Modify the pixels.
    For Y = 1 To hgt
        For X = 1 To wid
            ' Make the pixel black.
            pixels(pixR, X, Y) = 0
            pixels(pixG, X, Y) = 0
            pixels(pixB, X, Y) = 0

            If ((X \ 20) Mod 2) <> ((Y \ 20) Mod 2) Then
                ' Set the pixel color.
                pixels(clr, X, Y) = 255
            End If
        Next X
    Next Y

    ' Display the result.
    SetDIBits Picture1.hdc, Picture1.Image, _
        0, hgt, pixels(1, 1, 1), _
        bitmap_info, DIB_RGB_COLORS
    Picture1.Picture = Picture1.Image

    stop_time = Timer
    Screen.MousePointer = vbDefault
    MsgBox Format(stop_time - start_time, "0.00") & " seconds", _
        vbOKOnly, _
        Format$(wid + 1) & "x" & Format$(hgt + 1)
End Sub

Private Sub Form_Load()
    ScaleMode = vbPixels

    Picture1.AutoRedraw = True
    Picture1.ScaleMode = vbPixels
End Sub
Private Sub Form_Resize()
    Picture1.Move 0, 0, ScaleWidth, ScaleHeight
    Caption = Format$(ScaleWidth, "0") & "x" & Format$(ScaleHeight, "0")
End Sub
